"use strict"
// базовый общий для всех
XHEBaseObject = require("../../xhe_base.js")

/////////////////////////////////////////// Plgn_CSV ////////////////////////////////////////
class XHECSV extends XHEBaseObject
{
///////////////////////////////// SERVICE FUNCTIONS ////////////////////////////////////////////////
    // server initialization
    constructor(server, password = "") {
	    super(server, password, "Plgn_CSV")
    }
/////////////////////////////////////////////////////////////////////////////////////////////////////

    // Получить значение ячейки
    get_cell(path, row, col) {
        const params = ["path", path, "row", row, "col", col]
        return this.call_get("get_cell", params)
    }

    // Получить число строк в файле
    get_rows_count(path) {
        const params = ["path", path]
        return this.call_get("get_rows_count", params)
    }

    // Получить текстовое представление строки
    get_row(path, row) {
        const params = ["path", path, "row", row]
        return this.call_get("get_row", params)
    }

    // Добавить строку в конец файла
    add_row(path, row_content) {
        const params = ["path", path, "row_content", row_content]
        return this.call_get("add_row", params)
    }

    // Добавить несколько строк в конец файла
    add_rows(path, rows_content) {
        const params = ["path", path, "rows_content", rows_content]
        return this.call_get("add_rows", params)
    }

    // Добавить строку после номера указанной строки
    add_row_by_index(path, row_content, row) {
        const params = ["path", path, "row_content", row_content, "row", row]
        return this.call_get("add_row_by_index", params)
    }

    // Удалить строку
    remove_row(path, row) {
        const params = ["path", path, "row", row]
        return this.call_get("remove_row", params)
    }

    // Удалить строки
    remove_rows(path, rows) {
        const params = ["path", path, "rows", rows]
        return this.call_get("remove_rows", params)
    }

    // Очистить строку
    clear_row(path, row) {
        const params = ["path", path, "row", row]
        return this.call_get("clear_row", params)
    }

    // Заменить строку
    change_row(path, row, row_content) {
        const params = ["path", path, "row", row, "row_content", row_content]
        return this.call_get("change_row", params)
    }

    // Получить число столбцов в файле по номеру строки
    get_cols_count(path, row=0) {
        const params = ["path", path, "row", row]
        return this.call_get("get_cols_count", params)
    }

    // Получить значения столбца, разделенные новой строкой
    get_col(path, col) {
        const params = ["path", path, "col", col]
        return this.call_get("get_col", params)
    }

    // Добавить столбец
    add_col(path, col, col_content) {
        const params = ["path", path, "col", col, "col_content", col_content]
        return this.call_get("add_col", params)
    }

    // Удалить столбец
    remove_col(path, col) {
        const params = ["path", path, "col", col]
        return this.call_get("remove_col", params)
    }

    // Очистить столбец
    clear_col(path, col) {
        const params = ["path", path, "col", col]
        return this.call_get("clear_col", params)
    }
}
module.exports = XHECSV
