<?php
/////////////////////////////////////////// Plgn_CSV //////////////////////////////////////
class XHECSV extends XHEBaseObject
{
//////////////////////////// SERVICE FUNCTIONS /////////////////////////////////////////////////////
    // server initialization
    private string $inner_number;

    function __construct(string $server, string $password="")
	{
		$this->server = $server;
		$this->password = $password;
		$this->prefix = "Plgn_CSV";
	}
/////////////////////////////////////////////////////////////////////////////////////////////////////    
    
    // Получить значение ячейки
    function get_cell(string $path, int $row, int $col): string
    {
        $params = array( "path" => $path, "row" => $row, "col" => $col );
        return $this->call_get(__FUNCTION__, $params);
    }

    // Получить число строк в файле
    function get_rows_count(string $path): int
    {
        $params = array( "path" => $path );
        return $this->call_get(__FUNCTION__, $params);
    }

    // Получить текстовое представление строки
    function get_row(string $path, int $row): string
    {
        $params = array( "path" => $path, "row" => $row );
        return $this->call_get(__FUNCTION__, $params);
    }

    // Добавить строку в конец файла
    function add_row(string $path, string $row_content): bool
    {
        $params = array( "path" => $path, "row_content" => $row_content );
        return $this->call_get(__FUNCTION__, $params);
    }

    // Добавить несколько строк в конец файла
    function add_rows(string $path, string $rows_content): bool
    {
        $params = array( "path" => $path, "rows_content" => $rows_content );
        return $this->call_get(__FUNCTION__, $params);
    }

    // Добавить строку после номера указанной строки
    function add_row_by_index(string $path, string $row_content, int $row): bool
    {
        $params = array( "path" => $path, "row_content" => $row_content, "row" => $row );
        return $this->call_get(__FUNCTION__, $params);
    }

    // Удалить строку
    function remove_row(string $path, int $row): bool
    {
        $params = array( "path" => $path, "row" => $row );
        return $this->call_get(__FUNCTION__, $params);
    }

    // Удалить строки
    function remove_rows(string $path, string $rows): bool
    {
        $params = array( "path" => $path, "rows" => $rows );
        return $this->call_get(__FUNCTION__, $params);
    }

    // Очистить строку
    function clear_row(string $path, int $row): bool
    {
        $params = array( "path" => $path, "row" => $row );
        return $this->call_get(__FUNCTION__, $params);
    }

    // Заменить строку
    function change_row(string $path, int $row, string $row_content): bool
    {
        $params = array( "path" => $path, "row" => $row, "row_content" => $row_content );
        return $this->call_get(__FUNCTION__, $params);
    }

    // Получить число столбцов в файле по номеру строки
    function get_cols_count(string $path, int $row=0): int
    {
        $params = array( "path" => $path, "row" => $row );
        return $this->call_get(__FUNCTION__, $params);
    }

    // Получить значения столбца, разделенные новой строкой
    function get_col(string $path, int $col): string
    {
        $params = array( "path" => $path, "col" => $col );
        return $this->call_get(__FUNCTION__, $params);
    }

    // Добавить столбец
    function add_col(string $path, int $col, string $col_content): bool
    {
        $params = array( "path" => $path, "col" => $col, "col_content" => $col_content );
        return $this->call_get(__FUNCTION__, $params);
    }

    // Удалить столбец
    function remove_col(string $path, int $col): bool
    {
        $params = array( "path" => $path, "col" => $col );
        return $this->call_get(__FUNCTION__, $params);
    }

    // Очистить столбец
    function clear_col(string $path, int $col): bool
    {
        $params = array( "path" => $path, "col" => $col );
        return $this->call_get(__FUNCTION__, $params);
    }
};

?>
