from Objects.xhe_base import *


# Plgn_CSV
class XHECSV(XHEBaseObject):
    # server initialization
    def __init__(self, server: str, password: str=""):
        self.server = server
        self.password = password
        self.prefix = "Plgn_CSV"


    # Получить значение ячейки
    def get_cell(self, path: str, row: int, col: int) -> str:
        params = {"path": path, "row": row, "col": col}
        return self.call_get("get_cell", params)


    # Получить число строк в файле
    def get_rows_count(self, path: str) -> int:
        params = {"path": path}
        return self.call_get("get_rows_count", params)


    # Получить текстовое представление строки
    def get_row(self, path: str, row: int) -> str:
        params = {"path": path, "row": row}
        return self.call_get("get_row", params)


    # Добавить строку в конец файла
    def add_row(self, path: str, row_content: str) -> bool:
        params = {"path": path, "row_content": row_content}
        return self.call_get("add_row", params)


    # Добавить несколько строк в конец файла
    def add_rows(self, path: str, rows_content: str) -> bool:
        params = {"path": path, "rows_content": rows_content}
        return self.call_get("add_rows", params)


    # Добавить строку после номера указанной строки
    def add_row_by_index(self, path: str, row_content: str, row: int) -> bool:
        params = {"path": path, "row_content": row_content, "row": row}
        return self.call_get("add_row_by_index", params)


    # Удалить строку
    def remove_row(self, path: str, row: int) -> bool:
        params = {"path": path, "row": row}
        return self.call_get("remove_row", params)


    # Удалить строки
    def remove_rows(self, path: str, rows: str) -> bool:
        params = {"path": path, "rows": rows}
        return self.call_get("remove_rows", params)


    # Очистить строку
    def clear_row(self, path: str, row: int) -> bool:
        params = {"path": path, "row": row}
        return self.call_get("clear_row", params)


    # Заменить строку
    def change_row(self, path: str, row: int, row_content: str) -> bool:
        params = {"path": path, "row": row, "row_content": row_content}
        return self.call_get("change_row", params)


    # Получить число столбцов в файле по номеру строки
    def get_cols_count(self, path: str, row: int=0) -> int:
        params = {"path": path, "row": row}
        return self.call_get("get_cols_count", params)


    # Получить значения столбца, разделенные новой строкой
    def get_col(self, path: str, col: int) -> str:
        params = {"path": path, "col": col}
        return self.call_get("get_col", params)


    # Добавить столбец
    def add_col(self, path: str, col: int, col_content: str) -> bool:
        params = {"path": path, "col": col, "col_content": col_content}
        return self.call_get("add_col", params)


    # Удалить столбец
    def remove_col(self, path: str, col: int) -> bool:
        params = {"path": path, "col": col}
        return self.call_get("remove_col", params)


    # Очистить столбец
    def clear_col(self, path: str, col: int) -> bool:
        params = {"path": path, "col": col}
        return self.call_get("clear_col", params)

